// XbotCDef.h definitions et fonctions 
#define bLed 5 // pin 13  debug
#define LedOn  digitalWrite (13,HIGH) 
#define LedOff digitalWrite (13,LOW)
#define LedToggle PORTB ^= 1<<bLed 

//Definitions PWM and PFM
#define bBackL 4  // left motor on PORTD
#define bForwL 5  // rpwm possible
#define bForwR 6  // rpwm possible  
#define bBackR 7  // right motor
// Definitions PFM lib
#define ForwLeft  bitSet  (PORTD,bForwL); bitClear(PORTD,bBackL)
#define BackLeft  bitClear(PORTD,bForwL); bitSet  (PORTD,bBackL)
#define StopLeft  bitClear(PORTD,bForwL); bitClear(PORTD,bBackL)
#define ForwRight bitSet  (PORTD,bForwR); bitClear(PORTD,bBackR)
#define BackRight bitClear(PORTD,bForwR); bitSet  (PORTD,bBackR)
#define StopRight bitClear(PORTD,bForwR); bitClear(PORTD,bBackR)
// Panic motor stop
#define StopAll  PORTD &= 0b00001111 

// Whiskers on PORTD Active Low, can be written to activate the Leds
// but do not forget to update direction
#define bWhiskLeft  2 // PORTD,2)
#define bWhiskRight 3
#define ObsL  !(PIND&(1<<bWhiskLeft))  
#define ObsR  !(PIND&(1<<bWhiskRight)) 

#define  LedWLOn  bitSet   (DDRD,bWhiskLeft) ;bitClear (PORTB,bWhiskLeft)
#define  LedWLOff bitClear (DDRD,bWhiskLeft)
#define  LedWROn  bitSet   (DDRD,bWhiskRight);bitClear (PORTB,bWhiskRight)
#define  LedWROff bitClear (DDRD,bWhiskRight)

// Loudspeaker on RxD pin1  powered through a capacitor, no static current
#define bHp 1  // TxD  bit 1 PORTD 
#define  HpOn  bitSet   (PORTD,bS1)
#define  HpOff bitClear (PORTD,bS1)
#define  HpToggle PORTD ^= (1<<bS1)

void SetupXbot ()  {
   DDRD  |= 0b11110000 ; // force les 1 out
   DDRD  &= 0b11110011 ; // force les 0 in
   PORTD &= 0x0F ; // --> 0 Mot stop
   DDRB  |= 1<<bLed ; // Led13 
}

