// Debug.h 
volatile int highLow;
byte flagS1;  // envoi toutes les 20ms
 
#define bS1 5 // PORTB pin 13
#define S1On bitSet (PORTB,bS1)
#define S1Off bitClear (PORTB,bS1)
#define S1dirOut  bitSet   (DDRB,bS1)
#define S1In  (PORTB & (1<<bS1)) // avec Tell il ne faut pas lire la pin
 
#define TstOn bitSet (PORTB,4)  // dépannage oscillo
#define TstOff bitClear (PORTB,4)
#define TstToggle PORTB ^= 1<<4
#define TstdirOut bitSet(DDRB,4)

void SetupDebug() { 
  S1dirOut;  TstdirOut;
}

#define Nbits 16  
enum {AtS1,DebS1,StartS1,BitS1,ContS1,StopS1} eS1 = AtS1; 
  volatile unsigned int hL;
  volatile byte cc, etatLed; 
void SendS1 () {   // appel toutes les 58 us
  switch (eS1) {
    case AtS1:  // on attend le flag de départ  
      if (flagS1) {  hL=highLow;  eS1 = DebS1;}
      break;
   case DebS1: // on sauv LED, pin 13 à 1
      if (!S1In) {etatLed=0; S1Off; }  else {etatLed=1;}
      cc=Nbits;  eS1 = StartS1;
      break;
   case StartS1:  //envoie bit
      S1On; eS1=BitS1;
      break; 
   case BitS1: // coupe si bit=0
     if (!(hL&0x8000)) S1Off;
     eS1 = ContS1; 
     break; 
   case ContS1:
      S1Off; hL <<=1;
      if (cc--) { eS1 = StartS1; }
      else  { eS1 = StopS1; }
      break;
    case StopS1:  
      if (!etatLed) { S1On; }
      flagS1=0; eS1 = AtS1;
      break;
  } // end switch
}


